//
//  NEXActivity.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 19/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEActivity.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents a user's physical activity, comprising a state and a mode.
 *
 * The state represents the main category of the activity, e.g. walking, running, and in vehicle.
 * The mode represents what type of vehicle is in use, if any.
 */
@interface NEXActivity : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype _Nonnull)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param activity NEActivity to copy from..
 */
- (instancetype)initWithActivity:(NEActivity)activity;

/**
 * Conversion copy constructor.
 * @param activity NEActivity to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithActivity:(NEActivity)activity confidence:(double)confidence;

/**
 * @param state State to assume.
 */
- (instancetype)initWithState:(NEActivityState)state;

/**
 * @param state State to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEActivityState)state confidence:(double)confidence;

/**
 * @param state State to assume.
 * @param modeOfTransport Mode of transport to assume.
 */
- (instancetype)initWithState:(NEActivityState)state
              modeOfTransport:(NEActivityMode)modeOfTransport;

/**
 * @param state State to assume.
 * @param modeOfTransport Mode of transport to assume.
 */
- (instancetype)initWithState:(NEActivityState)state
                         mode:(NEActivityMode)modeOfTransport
    __deprecated_msg("Use initWithState:modeOfTransport: instead.");

/**
 * @param state State to assume.
 * @param modeOfTransport Mode of transport to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEActivityState)state
              modeOfTransport:(NEActivityMode)modeOfTransport
                   confidence:(double)confidence;

/**
 * @param state State to assume.
 * @param modeOfTransport Mode of transport to assume.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithState:(NEActivityState)state
                         mode:(NEActivityMode)modeOfTransport
                   confidence:(double)confidence
    __deprecated_msg("Use initWithState:modeOfTransport:confidence: instead.");

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString* _Nonnull)string;

/**
 * The main category of activity.
 */
@property(nonatomic, readwrite) NEActivityState state;

/**
 * The type of vehicle in use, if any.
 */
@property(nonatomic, readwrite) NEActivityMode modeOfTransport;

@property(nonatomic, readonly) NEActivity value DEPRECATED_ATTRIBUTE;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

+ (NSString*)stringFromState:(NEActivityState)state;
+ (NSString*)stringFromMode:(NEActivityMode)mode;

/**
 * Strict equality comparison.
 *
 * @see NEActivity_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEActivity)c_val;

@end
NS_ASSUME_NONNULL_END
